unit hkey;

(* 
 * Delphi Sample Code provided by BITWISE MAGAZINE
 * 
 *      http://www.bitwisemag.com
 *
 * This code and information is provided "as is" without warranty of
 * any kind, either expressed or implied, including but not limited
 * to the implied warranties of merchantability and/or fitness for a
 * particular purpose.
 *
 * You may use and modify this code for your personal use only.
 * You may also redistribute this code providing that
 * a) No fee is charged and b) This copyright notice
 * is retained in the source code.
 *
 * You may not use this code for commercial purposes
 * without the express permission of the copyright holder
 *
 * Copyright (c) 2005 Huw Collingbourne 
 *
 *)
 
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure WMHotkey( Var msg: TWMHotkey );message WM_HOTKEY;
    procedure RegHotKeys;
    procedure UnRegHotKeys;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure TForm1.WMHotkey( Var msg: TWMHotkey );
begin
    Application.Restore;
    Application.BringToFront;

    case (msg.hotkey) of
      1 : ShowMessage('HotKey 1!');
      2 : ShowMessage('HotKey 2!');
      3 : ShowMessage('HotKey 3!');
    else ShowMessage('Unknown HotKey!');
  end;
end;

procedure TForm1.RegHotKeys;
begin
  if not RegisterHotkey (self.Handle, 1, MOD_CONTROL , ord('X')) then
    ShowMessage('Unable to assign Ctrl+X as hotkey.');
  if not RegisterHotkey (self.Handle, 2, MOD_ALT or MOD_SHIFT , VK_F2) then
    ShowMessage('Unable to assign ALT+SHIFT+F2 as hotkey.');
  if not RegisterHotkey (self.Handle, 3, MOD_CONTROL or MOD_ALT , ord('F')) then
    ShowMessage('Unable to assign CTRL+ALT+F as hotkey.');
end;

procedure TForm1.UnRegHotKeys;
begin
  UnRegisterHotkey( self.Handle, 1 );
  UnRegisterHotkey( self.Handle, 2 );
  if not UnRegisterHotkey( self.Handle, 3 ) then
    ShowMessage('HotKey 3 is not registered!');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   RegHotKeys;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UnRegHotKeys;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  RegHotKeys;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  UnRegHotKeys;
end;

end.
